
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

include 'include/function.inc'
include 'include/flags.inc'
include 'include/timedate.inc'       ;HTTP protocol
include 'include/math.inc'
include 'include_plugin_general/short_functions.inc'
include 'include/stringFunctions.inc'
;nclude 'include_plugin_only/plugin_handle_connection.inc'

;EXTRASIZE_LISTEN_AND_CLIENT_STRUCT_TCP equ psize*2 + 0x20 + psize + 0x20 ;We want 1 pointers in the Listen/Client session + sizeof(sockadr_in) and a sockaddr_in structure (remote addr) + sizeof(sockadr_in) and a sockaddr_in structure (local addr)
;EXTRASIZE_LISTEN_AND_CLIENT_STRUCT_HTTP equ psize

;sizeSubportedProtocols equ endSubportedProtocols - subportedProtocols

;option_1 equ 3 ;integer instead of a name
;option_3 equ 6 ;integer instead of a name


;include 'include_plugin_only/plugin_bind.inc'
;include 'include_plugin_only/plugin_listen.inc'
;include 'include_plugin_general/list_functions.inc'
include 'include/collection.inc'
include 'include_http_protocol/plugin_http_splitter.inc'
include 'include_http_protocol/plugin_http_responder.inc'

;------------------------------
;-----GetProtocolNames---------
;-----__asm_exchange_tables----
;------------------------------
;With this you can use the macro 'if used isNotPlugin'
virtual at 0
call isNotPlugin
isNotPlugin:
end virtual
include 'include_plugin_general/__asm_exchange_tables_GetProtocolNames.inc'
mymod pointer ?

;make a call to initGetSmallestPortionPageAllocation
main:
_init:
if used isWin
  StartProc 3
end if
call denter
  if used isWin
    cmp dword [pebp+psize*3],1 ;DLL_PROCESS_ATTACH
    jne dontInitDLL
  end if

    call initGetSmallestPortionPageAllocation

    if used is32 & used isWin
      call doSystemCheckDLL
    end if

    if used isWin
      mov peax,pdword [pebp+psize*2] ;get HMODULE
      mov [mymod],peax
    else
      pmov [mymod],_init
    end if

dontInitDLL:
  xor eax,eax
  inc eax
call dleave
if used isWin
  EndProc 3
end if
ret FunctionReturnFactor*3
