
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

;------------------------------------------------------------------------------
;This function will fill the buffer with user readable current GMT time and date (format orig-date in RFC 822)
;input:
;    1:Buffer
;output:
;    none
;corupted:
;    EAX
;------------------------------------------------------------------------------
if used GetGMTTime
GetGMTTime:
call denter
MakeStack

;SYSTEMTIME + SYSTEMTIME (with year =dword not word) + TIME_ZONE_INFORMATION(+4 align)
mov ecx,0x10+ 0x20 + 0xB0
sub pesp,pecx

;zero the structures
mov pedi,pesp
xor eax,eax
rep stosb

push pesp ;SYSTEMTIME
mfcall [GetLocalTime],1

lea peax,pdword [pesp+0x30] ;pointer to TIME_ZONE_INFORMATION

push peax ;TIME_ZONE_INFORMATION
mfcall [GetTimeZoneInformation],1

lea pecx,pdword [pesp+0x30] ;EAX = Bias pointer
neg dword [pecx]            ;Bias = -Bias

lea peax,pdword [pesp+0x30+0xA8] ;EAX = DaylightBias pointer  ;0xB8
neg dword [peax]            ;DaylightBias = -DaylightBias

lea pesi,pdword [pesp+0x20] ;output SYSTEMTIME

mov peax,pesp ;input SYSTEMTIME

push pesi ;output SYSTEMTIME
push peax ;input SYSTEMTIME
push pecx ;TIME_ZONE_INFORMATION
mfcall [SystemTimeToTzSpecificLocalTime],3

;convert year from word to a dword
xor eax,eax
lodsw
sub pesi,4
mov dword [pesi],eax

push pdword [pebp+psize*2] ;buffer
push pesi                  ;output SYSTEMTIME (EDITED: YEAR => Dword, not WORD)
call SystemTimeToString

call dleave
ret psize
end if

