;------------------------------------------------------------------------------
;This function returns a pointer to the filename that is in the input path string
;input:
;    1:Path string (UTF-16) (on Windows)
;    1:Path string (UTF-8) (on Linux)



;output:
;       Pointer to filename
;------------------------------------------------------------------------------

GetFilenameFromPath:
call denter

;add a end the of filename and add a quote there
mov pedi,pdword [pebp+(psize*2)]
push pedi
if used isLin
  call strlen
else
  call strlenW
end if
add pedi,peax ;seek to the end of the string

if used isWin
  shr peax,1
end if
mov pecx,peax   ;repeat times the stringis big

mov eax,DIR_SEPERATOR  ; byte to find with scasb => '\\' or '/'

STD ;execute scasb function backward
if used isWin
  repnz scasw   ;loop string until something else then a zero word is found
else
  repnz scasb   ;loop string until something else then a zero byte is found
end if
CLD ;clear backward direction

mov peax,pedi
if used isLin
  add peax,2
else
  add peax,4
end if 
call dleave
ret psize