@echo off
SET INCLUDE=C:\fasm\INCLUDE
SET @FASM_COMPILER=C:\fasm\FASM.EXE

net session >nul 2>&1
if %errorLevel%==0 goto runningasadmin

set "batchPath=%~f0"

echo This script needs admin priviliges to be able to install TV's server v3.01.
echo Starting as admin...
REM Try to start the script with admin priviliges
ECHO Set UAC = CreateObject^("Shell.Application"^) > "%temp%\OEgetPrivileges.vbs"
ECHO UAC.ShellExecute "cmd", "/c ""%batchPath% """, "%~dp0\", "runas", 1 >> "%temp%\OEgetPrivileges.vbs"
"%temp%\OEgetPrivileges.vbs" 
exit /B

:runningasadmin
cd %~dp0
SET @DIR=%~dp0
%@DIR:~0,2%
  
echo Welcome to the installer of TV's server v3.20
echo Please check the settings below before continue
echo --
echo FASM compiler path: %@FASM_COMPILER%
echo FASM include folder: %INCLUDE%
echo --
echo Modify this file if not correct.
pause
cls

for %%i in (*.asm) do (
  %@FASM_COMPILER% %%i
)
echo ----
echo All files in this folder are now compiled. Please fix errors if any and restart this bat-file to retry. 
echo If  no error, press space to continue.
pause
cls

SET @EXTRABYTES=
SET @COMPILE_ARCHITECTURE=x86
SET @BASE_NUMBER=32
set @REGISTRY_BASE=HKLM\SOFTWARE\TV's software\TV's server v3
set @REGISTRY_PATH=SOFTWARE\TV's software\TV's server v3
set @SysDir=%SystemRoot%\System32\
if not "%PROCESSOR_ARCHITECTURE%"=="AMD64" goto 32BIT

set @REGISTRY_BASE=HKLM\SOFTWARE\WOW6432Node\TV's software\TV's server v3
set @REGISTRY_PATH=SOFTWARE\WOW6432Node\TV's software\TV's server v3
set @SysDir=%SystemRoot%\SysWOW64\
:loop
echo Would you like to install the 32-bit version or the 64-bit version?
echo --
echo 1:32-bit
echo 2:64-bit
set /p id="Enter [1-2, default 2]: "
if "%id%"=="" goto 64BIT
if %id%==1 goto 32BIT
if not %id%==2 goto loop

:64BIT
set @REGISTRY_BASE=HKLM\SOFTWARE\TV's software\TV's server v3
set @REGISTRY_PATH=SOFTWARE\TV's software\TV's server v3
set @SysDir=%SystemRoot%\System32\
SET @COMPILE_ARCHITECTURE=x64
SET @BASE_NUMBER=64
SET @EXTRABYTES=00000000

:32BIT
:ASKPORTNUMBER
  set DEC=

  set /P DEC=" On which port should the control panel run? (1-65535, default 10): "
  SET "var="&for /f "delims=0123456789" %%i in ("%DEC%") do set var=%%i
  if defined var goto ASKPORTNUMBER
  if "%DEC%"==""  goto setDefaultPort
  if %DEC% gtr 65535 goto ASKPORTNUMBER

  cmd /C exit %DEC%
  set "HEX=%=ExitCode%"

  if not %HEX%==00000000 goto isNotZeroPort
  :setDefaultPort
  SET HEX=0000000A
  set DEC=10
  :isNotZeroPort
  SET FIRSTBYTE=%HEX:~6,2%
  SET SECONDBYTE=%HEX:~4,2%

SET str=%ComSpec%
set str=%str:cmd.exe=%
if not exist %str%reg.exe goto writeRegFile

echo Setting Registry
reg add "%@REGISTRY_BASE%\Modules" /v "Control panel plug-in" /t REG_SZ /d "%~dp0\tvs_server_plugin_control_panel_%@COMPILE_ARCHITECTURE%.dll"
reg add "%@REGISTRY_BASE%\Modules" /v "HTTP plug-in" /t REG_SZ /d "%~dp0\tvs_server_plugin_http_%@COMPILE_ARCHITECTURE%.dll"
reg add "%@REGISTRY_BASE%\Modules" /v "Limit Connections plug-in" /t REG_SZ /d "%~dp0\tvs_server_plugin_limit_connections_%@COMPILE_ARCHITECTURE%.dll"
reg add "%@REGISTRY_BASE%\Modules" /v "TCP/IP plug-in" /t REG_SZ /d "%~dp0\tvs_server_plugin_tcp_protocol_%@COMPILE_ARCHITECTURE%.dll"

reg add "%@REGISTRY_BASE%\ListenSessions\1" /v "BindedToProtocols" /t REG_MULTI_SZ /d TVS_SOFTWARE_TCPIP\0TVS_SOFTWARE_CONTROLPANEL
reg add "%@REGISTRY_BASE%\ListenSessions\1" /v "Name" /t REG_SZ /d "Control panel"

reg add "%@REGISTRY_BASE%\ListenSessions\1\TVS_SOFTWARE_CONTROLPANEL" /v ProtocolType /t REG_DWORD /d 196610
reg add "%@REGISTRY_BASE%\ListenSessions\1\TVS_SOFTWARE_TCPIP" /v ProtocolType /t REG_DWORD /d 0
reg add "%@REGISTRY_BASE%\ListenSessions\1\TVS_SOFTWARE_TCPIP\listById" /v 3 /t REG_BINARY /d %FIRSTBYTE%%SECONDBYTE%0000%@EXTRABYTES%
goto finishInstallation

:writeRegFile
echo REGEDIT4 > reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%]>> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions]>> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions\1]>> reg.reg
echo "BindedToProtocols"=hex(7):54,56,53,5f,53,4f,46,54,57,41,52,45,5f,54,43,50,49,\>> reg.reg
echo   50,00,54,56,53,5f,53,4f,46,54,57,41,52,45,5f,43,4f,4e,54,52,4f,4c,50,41,4e,\>> reg.reg
echo   45,4c,00,00>> reg.reg
echo "Name"="Control panel">> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions\1\TVS_SOFTWARE_CONTROLPANEL]>> reg.reg
echo "ProtocolType"=dword:00030002>> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions\1\TVS_SOFTWARE_TCPIP]>> reg.reg
echo "ProtocolType"=dword:00000000>> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\ListenSessions\1\TVS_SOFTWARE_TCPIP\listById]>> reg.reg
echo "3"=hex:%FIRSTBYTE%,%SECONDBYTE%,00,00>> reg.reg
echo.>> reg.reg
echo [HKEY_LOCAL_MACHINE\%@REGISTRY_PATH%\Modules]>> reg.reg
set string=%~dp0\tvs_server_plugin_control_panel_%@COMPILE_ARCHITECTURE%.dll
set newString=
call :dubbleSlash
echo "Control panel plug-in"="%newString%">> reg.reg
set string=%~dp0\tvs_server_plugin_http_%@COMPILE_ARCHITECTURE%.dll
set newString=
call :dubbleSlash
echo "HTTP plug-in"="%newString%">> reg.reg
set string=%~dp0\tvs_server_plugin_limit_connections_%@COMPILE_ARCHITECTURE%.dll
set newString=
call :dubbleSlash
echo "Limit Connections plug-in"="%newString%">> reg.reg
set string=%~dp0\tvs_server_plugin_tcp_protocol_%@COMPILE_ARCHITECTURE%.dll
set newString=
call :dubbleSlash
echo "TCP/IP plug-in"="%newString%">> reg.reg
echo.>> reg.reg
echo.>> reg.reg

start /wait regedit %~dp0\reg.reg

:finishInstallation
echo Uninstalling service if exist...
start /wait base%@BASE_NUMBER%_win.exe -u

echo copying tvs_server_http_protocol_%@COMPILE_ARCHITECTURE%.dll to the system directory..
echo If this step fails, please copy manually to %@SysDir%
copy /Y "%~dp0\tvs_server_http_protocol_%@COMPILE_ARCHITECTURE%.dll" "%@SysDir%\tvs_server_http_protocol_%@COMPILE_ARCHITECTURE%.dll"

echo Installing service...
start /wait base%@BASE_NUMBER%_win.exe -i

echo Starting service...
start /wait base%@BASE_NUMBER%_win.exe

echo Starting control panel
start http://127.0.0.1:%DEC%/
pause
exit /B

:dubbleSlash
set CHAR=%string:~0,1%

if "%CHAR%"==" " goto notBackSlash

if %CHAR%==\ (
set CHAR=\\
)
:notBackSlash
set newString=%newString%%CHAR%
set string=%string:~1%
if not "%string%"=="" goto dubbleSlash
goto :eof